> ## Documentation Index
> Fetch the complete documentation index at: https://www.helius.dev/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# getShieldedTransactionsByNullifiers

> Truy xuất các sự kiện giao dịch được che chắn đã chi tiêu những nullifier được cung cấp.

## Tìm các giao dịch chi tiêu

Sử dụng các nullifier do ví của bạn tạo ra để tìm những giao dịch đã chi tiêu các đầu vào của ví. Các nullifier dùng để chọn giao dịch. Mỗi mục trong `result.data` chứa mọi sự kiện của một giao dịch Solana được chọn, cùng với `slot` và `signature` của giao dịch đó.

Cung cấp từ 1 đến 1.000 nullifier. Xem [phân trang và độ mới của dữ liệu](https://www.helius.dev/docs/vi/api-reference/privacy.md#phân-trang) để biết giới hạn trang, token tiếp tục và cách đọc tăng dần.

## Tham số yêu cầu

**filters** `object`

Giới hạn slot. Tiếp tục một lượt đọc không giới hạn đã bắt kịp bằng cách đặt `slot.gt` thành `context.slot` của trang cuối cùng.

**filters.slot** `object`

Giới hạn slot cho lượt đọc. Các giới hạn được cung cấp sẽ được kết hợp bằng AND.

**filters.slot.gt** `number`

Chỉ bao gồm các giao dịch sau slot này.

**filters.slot.gte** `number`

Chỉ bao gồm các giao dịch tại hoặc sau slot này.

**filters.slot.lt** `number`

Chỉ bao gồm các giao dịch trước slot này.

**filters.slot.lte** `number`

Chỉ bao gồm các giao dịch tại hoặc trước slot này.

**limit** `number` (default: 1000)

Số lượng giao dịch Solana tối đa trên mỗi trang, từ 1 đến 1.000.

**minContextSlot** `number`

Slot tối thiểu đã được trình lập chỉ mục lưu bền vững cần có cho lượt đọc này. Trả về lỗi JSON-RPC -32016 nếu trình lập chỉ mục bị chậm.

**nullifiers** `array` *required*

Các nullifier 32 byte được mã hóa Base58 để đối chiếu với những đầu vào đã chi tiêu.

**paginationToken** `string`

Token tiếp tục từ phản hồi trước. Gửi lại token này mà không thay đổi, cùng với các nullifier và bộ lọc slot giống nhau.


## OpenAPI

````yaml vi/openapi/privacy/getShieldedTransactionsByNullifiers.yaml POST /v1/spr/getShieldedTransactionsByNullifiers
openapi: 3.0.3
info:
  title: Solana Privacy Rings API
  version: 0.51.2
  description: >-
    API JSON-RPC của trình lập chỉ mục quyền riêng tư dành cho trạng thái mã
    hóa, lịch sử, bằng chứng và các bản ghi đăng ký công khai.
servers:
  - url: https://devnet.helius-rpc.com
    description: Solana Privacy Rings API trên Devnet
security: []
paths:
  /v1/spr/getShieldedTransactionsByNullifiers:
    post:
      summary: getShieldedTransactionsByNullifiers
      description: >-
        Truy xuất các sự kiện giao dịch được che giấu có chi tiêu những
        nullifier đã cung cấp.
      operationId: getShieldedTransactionsByNullifiers
      requestBody:
        content:
          application/json:
            schema:
              type: object
              required:
                - jsonrpc
                - id
                - method
                - params
              properties:
                id:
                  type: string
                  description: ID dùng để nhận dạng yêu cầu.
                  default: '1'
                jsonrpc:
                  type: string
                  description: Phiên bản giao thức JSON-RPC.
                  enum:
                    - '2.0'
                  default: '2.0'
                method:
                  type: string
                  description: >-
                    Phương thức cần gọi. Phải khớp với phân đoạn cuối cùng của
                    đường dẫn URL.
                  enum:
                    - getShieldedTransactionsByNullifiers
                  default: getShieldedTransactionsByNullifiers
                params:
                  type: object
                  required:
                    - nullifiers
                  properties:
                    filters:
                      allOf:
                        - $ref: '#/components/schemas/HistoryFilters'
                      description: >-
                        Các giới hạn slot. Để tiếp tục một lần đọc không giới
                        hạn đã bắt kịp, hãy đặt `slot.gt` thành `context.slot`
                        của trang cuối cùng.
                    limit:
                      type: integer
                      format: uint64
                      maximum: 1000
                      minimum: 1
                      nullable: true
                      default: 1000
                      description: >-
                        Số lượng giao dịch Solana tối đa trên mỗi trang, từ 1
                        đến 1.000.
                    minContextSlot:
                      type: integer
                      format: uint64
                      minimum: 0
                      nullable: true
                      description: >-
                        Slot tối thiểu đã được trình lập chỉ mục lưu bền vững,
                        cần thiết cho lần đọc này. Trả về lỗi JSON-RPC -32016
                        nếu trình lập chỉ mục bị chậm.
                    nullifiers:
                      type: array
                      items:
                        $ref: '#/components/schemas/Hash'
                      minItems: 1
                      maxItems: 1000
                      description: >-
                        Các nullifier 32 byte được mã hóa base58 để đối chiếu
                        với đầu vào đã chi tiêu.
                    paginationToken:
                      type: string
                      description: >-
                        Token tiếp tục từ phản hồi trước. Truyền lại nguyên
                        trạng cùng các nullifier và bộ lọc slot giống nhau.
                      nullable: true
                  additionalProperties: false
                  example:
                    nullifiers:
                      - '11111111111111111111111111111112'
                    limit: 100
            example:
              jsonrpc: '2.0'
              id: '1'
              method: getShieldedTransactionsByNullifiers
              params:
                nullifiers:
                  - '11111111111111111111111111111112'
                limit: 100
        required: true
      responses:
        '200':
          description: Phản hồi JSON-RPC. Kiểm tra lỗi trước khi đọc kết quả.
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                properties:
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
                  id:
                    type: string
                    description: ID của yêu cầu.
                  jsonrpc:
                    type: string
                    description: Phiên bản của giao thức JSON-RPC.
                    enum:
                      - '2.0'
                  result:
                    type: object
                    description: >-
                      Một trang có giới hạn của lần đọc lịch sử, sử dụng cách
                      phân trang kiểu gTFA.
                    required:
                      - context
                      - data
                      - paginationToken
                    properties:
                      context:
                        $ref: '#/components/schemas/Context'
                      data:
                        type: array
                        items:
                          type: object
                          description: >-
                            Các sự kiện được trả về của một giao dịch Solana,
                            theo thứ tự sự kiện.
                          required:
                            - slot
                            - signature
                            - events
                          properties:
                            events:
                              type: array
                              items:
                                $ref: '#/components/schemas/ShieldedTransaction'
                            signature:
                              $ref: '#/components/schemas/SerializableSignature'
                            slot:
                              type: integer
                              format: uint64
                              minimum: 0
                          additionalProperties: false
                      outputTreeId:
                        type: integer
                        format: uint16
                        description: >-
                          ID của cây trạng thái mới nhất không bị tạm dừng. Bị
                          lược bỏ khi không khả dụng.
                        minimum: 0
                      paginationToken:
                        type: string
                        description: >-
                          Token cho trang tiếp theo; là null khi không còn kết
                          quả phù hợp. Một lần đọc

                          đã bắt kịp mà không có giới hạn `lt` hoặc `lte` sẽ
                          tiếp tục sau đó với `filters.slot.gt`

                          được đặt thành `context.slot` của trang này; một lần
                          đọc có giới hạn trên chỉ bao gồm các slot đến

                          giới hạn đó.
                        nullable: true
              example:
                jsonrpc: '2.0'
                id: '1'
                result:
                  context:
                    slot: 4242
                    blockTime: 1730000000
                  data: []
                  paginationToken: null
        '400':
          description: >-
            Bị từ chối trước khi thực thi. Phương thức không khớp đường dẫn,
            trường phương thức bị trùng lặp hoặc yêu cầu theo lô sẽ trả về
            -32601. Nội dung không thể đọc hoặc quá lớn sẽ trả về -32600.
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: >-
                      ID yêu cầu hoặc null khi nội dung không phải là một lệnh
                      gọi JSON-RPC đơn lẻ.
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
        '429':
          description: Đã vượt quá giới hạn tốc độ.
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: >-
                      ID yêu cầu hoặc null khi nội dung không phải là một lệnh
                      gọi JSON-RPC đơn lẻ.
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
        '500':
          description: Lỗi máy chủ nội bộ.
          content:
            application/json:
              schema:
                type: object
                required:
                  - jsonrpc
                  - id
                  - error
                properties:
                  jsonrpc:
                    type: string
                    enum:
                      - '2.0'
                  id:
                    type: string
                    nullable: true
                    description: >-
                      ID yêu cầu hoặc null khi nội dung không phải là một lệnh
                      gọi JSON-RPC đơn lẻ.
                  error:
                    type: object
                    required:
                      - code
                      - message
                    properties:
                      code:
                        type: integer
                      message:
                        type: string
                      data:
                        type: object
                        additionalProperties: true
      security:
        - ApiKeyQuery: []
components:
  schemas:
    HistoryFilters:
      type: object
      description: Các giới hạn slot tùy chọn cho truy vấn lịch sử.
      properties:
        slot:
          $ref: '#/components/schemas/SlotFilter'
      additionalProperties: false
    Hash:
      type: string
      description: Hàm băm 32 byte được mã hóa base58.
    Context:
      type: object
      required:
        - blockTime
        - slot
      properties:
        blockTime:
          type: integer
          format: int64
        slot:
          type: integer
          format: uint64
          description: >-
            Slot cao nhất mà trình lập chỉ mục đã lưu bền vững, dùng để kiểm tra
            độ mới dựa trên slot.
          minimum: 0
    ShieldedTransaction:
      type: object
      required:
        - slot
        - txSignature
        - txViewingPk
        - salt
        - outputSlots
        - messages
        - nullifiers
        - proofless
      properties:
        eventIndex:
          type: integer
          format: uint16
          minimum: 0
        messages:
          type: array
          items:
            $ref: '#/components/schemas/RingsMessage'
          description: >-
            Các slot dữ liệu đã công bố không gắn với cam kết đầu ra nào, được
            công bố lại nguyên trạng.
        nullifiers:
          type: array
          items:
            $ref: '#/components/schemas/Hash'
        outputSlots:
          type: array
          items:
            $ref: '#/components/schemas/RingsOutputSlot'
        proofless:
          type: boolean
          description: True khi ít nhất một đầu ra trong giao dịch này không có bằng chứng.
        ringConfig:
          type: string
          description: >-
            Tài khoản cấu hình của ring (`ring_auth` PDA của ring). Bị lược bỏ
            khi không có ring nào cấp quyền cho giao dịch này.
        ringProgramId:
          type: string
          description: >-
            Chương trình của ring, được phân giải thông qua các đăng ký đã lập
            chỉ mục. Bị lược bỏ khi `ringConfig` bị lược bỏ hoặc đăng ký của
            ring chưa được lập chỉ mục. Dùng `ringConfig` để phân biệt "không có
            ring" với "ring có chương trình chưa được lập chỉ mục".
        salt:
          type: string
          description: Salt AES ở cấp giao dịch được dùng chung cho bản mã của mọi đầu ra.
          nullable: true
        slot:
          type: integer
          format: uint64
          minimum: 0
        txSignature:
          $ref: '#/components/schemas/SerializableSignature'
        txViewingPk:
          type: string
          description: Chuỗi byte được mã hóa base64.
          nullable: true
    SerializableSignature:
      type: string
      description: Chữ ký giao dịch Solana 64 byte được mã hóa base58.
    SlotFilter:
      type: object
      description: >-
        Các giới hạn slot cho lần đọc. Các giới hạn được cung cấp được kết hợp
        bằng AND.
      properties:
        gt:
          type: integer
          format: uint64
          minimum: 0
          nullable: true
          description: Chỉ bao gồm các giao dịch sau slot này.
        gte:
          type: integer
          format: uint64
          minimum: 0
          nullable: true
          description: Chỉ bao gồm các giao dịch tại hoặc sau slot này.
        lt:
          type: integer
          format: uint64
          minimum: 0
          nullable: true
          description: Chỉ bao gồm các giao dịch trước slot này.
        lte:
          type: integer
          format: uint64
          minimum: 0
          nullable: true
          description: Chỉ bao gồm các giao dịch tại hoặc trước slot này.
      additionalProperties: false
    RingsMessage:
      type: object
      required:
        - viewTag
        - payload
      properties:
        payload:
          $ref: '#/components/schemas/Base64String'
        viewTag:
          $ref: '#/components/schemas/Hash'
    RingsOutputSlot:
      type: object
      required:
        - viewTag
        - outputContext
        - payload
      properties:
        outputContext:
          $ref: '#/components/schemas/RingsOutputContext'
        payload:
          $ref: '#/components/schemas/Base64String'
        viewTag:
          $ref: '#/components/schemas/Hash'
    Base64String:
      type: string
      description: Chuỗi byte được mã hóa base64.
    RingsOutputContext:
      type: object
      required:
        - hash
        - tree
        - treeId
        - leafIndex
      properties:
        hash:
          $ref: '#/components/schemas/Hash'
        leafIndex:
          type: integer
          format: uint64
          minimum: 0
        tree:
          allOf:
            - $ref: '#/components/schemas/SerializablePubkey'
          description: >-
            Tài khoản cây trạng thái. Ưu tiên treeId; tài khoản cây được dẫn
            xuất từ giá trị này.
          deprecated: true
        treeId:
          type: integer
          format: uint16
          description: ID cây thô mà cam kết của đầu ra được băm bên dưới.
          minimum: 0
    SerializablePubkey:
      type: string
      description: Khóa công khai Solana được mã hóa base58.
  securitySchemes:
    ApiKeyQuery:
      type: apiKey
      in: query
      name: api-key
      description: Khóa API Helius của bạn.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.